/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 * 
 *  Gabber 2
 *  Based on Gabber, Copyright (c) 1999-2002 Dave Smith & Julian Missig
 *  Copyright (c) 2002 Julian Missig
 */

#include "BaseGabberWindow.hh"
#include "Environment.hh"

#include <libglademm/xml.h>

namespace Gabber {

// ---------------------------------------------------------
//
// Base Gabber Window
//
// ---------------------------------------------------------
BaseGabberWindow::BaseGabberWindow(const Glib::ustring& widgetname)
     : _thisXml(Gnome::Glade::Xml::create(ENV_VARS.pkgdatadir + widgetname + ".glade", widgetname)), _thisWindow(0)
{ 
     // Get the Gtk::Window
     _thisXml->get_widget(widgetname, _thisWindow);
     // ref this SigC::Object
     reference();

     _thisWindow->signal_delete_event().connect(slot(*this, &BaseGabberWindow::on_delete_event));
}

void BaseGabberWindow::close()
{
     // unref this SigC::Object
     unreference();
}

BaseGabberWindow::~BaseGabberWindow()
{
     // destroy the Gtk::Window
     delete _thisWindow;
}

bool BaseGabberWindow::on_delete_event(GdkEventAny* e)
{
     close();
}

} // namespace Gabber
